diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/libraw/libraw_datastream.h libkdcraw/libkdcraw/libraw/libraw/libraw_datastream.h
--- libkdcraw-wrk/libkdcraw/libraw/libraw/libraw_datastream.h	2022-11-07 08:15:53.614821808 +0300
+++ libkdcraw/libkdcraw/libraw/libraw/libraw_datastream.h	2022-11-07 07:46:31.726795008 +0300
@@ -1,24 +1,19 @@
 /* -*- C -*-
  * File: libraw_datastream.h
- * Copyright 2008-2009 Alex Tutubalin <lexa@lexa.ru>
+ * Copyright 2008-2020 LibRaw LLC (info@libraw.org)
  * Created: Sun Jan 18 13:07:35 2009
  *
  * LibRaw Data stream interface
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
- * 02110-1301, USA.
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
  */
 
 #ifndef __LIBRAW_DATASTREAM_H
@@ -31,273 +26,274 @@
 
 #ifndef __cplusplus
 
-struct LibRaw_abstract_datastream;
-
-#else // __cplusplus
+#else /* __cplusplus */
+#if defined _WIN32
+#ifndef LIBRAW_NO_WINSOCK2
+#include <winsock2.h>
+#endif
+#endif
+/* No unique_ptr on Apple ?? */
+#if __cplusplus >= 201103L || (defined(_CPPLIB_VER) && _CPPLIB_VER >= 520) ||  \
+    (defined(_MSC_VER) && _MSVC_LANG >= 201103L)
+/* OK - use unique_ptr unless LIBRAW_USE_AUTOPTR defined externally*/
+#else
+/* Force to use auto_ptr */
+#ifndef LIBRAW_USE_AUTOPTR
+#define LIBRAW_USE_AUTOPTR
+#endif
+#endif
 
 #include "libraw_const.h"
+#include "libraw_types.h"
+#include <fstream>
+#include <memory>
+#include <vector>
 
-class LibRaw_buffer_datastream;
+#if defined(_WIN32) && (_MSC_VER) >= 1500
+#define WIN32SECURECALLS
+#endif
 
-class LibRaw_abstract_datastream
-{
-  public:
-    LibRaw_abstract_datastream(){substream=0;};
-    virtual             ~LibRaw_abstract_datastream(void){if(substream) delete substream;}
-    virtual int         valid(){return 0;}
-    // file input emulation
-    virtual int         read(void *,size_t, size_t ){ return -1;}
-    virtual int         seek(off_t o, int whence){return -1;}
-    virtual int         tell(){return -1;}
-    virtual int         get_char(){return -1;}
-    virtual char*       gets(char *, int){ return NULL;}
-    virtual int         scanf_one(const char *, void *){return -1;}
-    virtual int         eof(){return -1;}
-
-    virtual const char* fname(){ return NULL;};
-    virtual int         subfile_open(const char*){ return EINVAL;}
-    virtual void        subfile_close(){}
-    virtual int		tempbuffer_open(void*, size_t);
-    virtual void	tempbuffer_close()
-    {
-        if(substream) delete substream;
-        substream = NULL;
-    }
+#ifdef USE_DNGSDK
 
-  protected:
-    LibRaw_abstract_datastream *substream;
-};
+#if defined LIBRAW_WIN32_CALLS
+#define qWinOS 1
+#define qMacOS 0
+#elif defined(__APPLE__)
+#define qWinOS 0
+#define qMacOS 1
+#else
+/* define OS types for DNG here */
+#endif
+#define qDNGXMPDocOps 0
+#define qDNGUseLibJPEG 1
+#define qDNGXMPFiles 0
+#define qDNGExperimental 1
+#define qDNGThreadSafe 1
+#include "dng_stream.h"
+#endif /* DNGSDK */
+
+#define IOERROR()                                                              \
+  do                                                                           \
+  {                                                                            \
+    throw LIBRAW_EXCEPTION_IO_EOF;                                             \
+  } while (0)
 
+class LibRaw_buffer_datastream;
+class LibRaw_bit_buffer;
 
-class LibRaw_file_datastream : public LibRaw_abstract_datastream
+class DllDef LibRaw_abstract_datastream
 {
-  public:
-    LibRaw_file_datastream(const char *fname) 
-        { 
-            if(fname)
-                {filename = fname; f = fopen(fname,"rb");}
-            else 
-                {filename=0;f=0;}
-            sav=0;
-        }
-
-    virtual ~LibRaw_file_datastream() {if(f)fclose(f); if(sav)fclose(sav);}
-
-    virtual int valid() { return f?1:0;}
-
-#define CHK() do {if(!f) throw LIBRAW_EXCEPTION_IO_EOF;}while(0)
-    virtual int read(void * ptr,size_t size, size_t nmemb) 
-    { 
-        CHK(); 
-        return substream?substream->read(ptr,size,nmemb):int(fread(ptr,size,nmemb,f));
-    }
-    virtual int eof() 
-    { 
-        CHK(); 
-        return substream?substream->eof():feof(f);
-    }
-    virtual int seek(off_t o, int whence) 
-    { 
-        CHK(); 
-        return substream?substream->seek(o,whence):fseek(f,o,whence);
-    }
-    virtual int tell() 
-    { 
-        CHK(); 
-        return substream?substream->tell():ftell(f);
-    }
-    virtual int get_char() 
-    { 
-        CHK(); 
-        return substream?substream->get_char():fgetc(f);
-    }
-    virtual char* gets(char *str, int sz) 
-    { 
-        CHK(); 
-        return substream?substream->gets(str,sz):fgets(str,sz,f);
-    }
-    virtual int scanf_one(const char *fmt, void*val) 
-    { 
-        CHK(); 
-        return substream?substream->scanf_one(fmt,val):fscanf(f,fmt,val);
-    }
+public:
+  LibRaw_abstract_datastream() { };
+  virtual ~LibRaw_abstract_datastream(void) { }
+  virtual int valid() = 0;
+  virtual int read(void *, size_t, size_t) = 0;
+  virtual int seek(INT64, int) = 0;
+  virtual INT64 tell() = 0;
+  virtual INT64 size() = 0;
+  virtual int get_char() = 0;
+  virtual char *gets(char *, int) = 0;
+  virtual int scanf_one(const char *, void *) = 0;
+  virtual int eof() = 0;
+  virtual void *make_jas_stream() = 0;
+  virtual int jpeg_src(void *);
+  virtual void buffering_off() {}
+  /* reimplement in subclass to use parallel access in xtrans_load_raw() if
+   * OpenMP is not used */
+  virtual int lock() { return 1; } /* success */
+  virtual void unlock() {}
+  virtual const char *fname() { return NULL; };
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  virtual const wchar_t *wfname() { return NULL; };
+#endif
+};
 
-    virtual const char *fname() { return filename; }
+#ifdef LIBRAW_WIN32_DLLDEFS
+#ifdef LIBRAW_USE_AUTOPTR
+template class DllDef std::auto_ptr<std::streambuf>;
+#else
+template class DllDef std::unique_ptr<std::streambuf>;
+#endif
+#endif
 
-    // secondary 
-    virtual int subfile_open(const char *fn)
-    {
-        if(sav) return EBUSY;
-        sav = f;
-        f = fopen(fn,"rb");
-        if(!f)
-            {
-                f = sav;
-                sav = NULL;
-                return ENOENT;
-            }
-        else
-            return 0;
-    }
-    virtual void subfile_close()
-    {
-        if(!sav) return;
-        fclose(f);
-        f = sav;
-        sav = 0;
-    }
+class DllDef LibRaw_file_datastream : public LibRaw_abstract_datastream
+{
+protected:
+#ifdef LIBRAW_USE_AUTOPTR
+  std::auto_ptr<std::streambuf> f; /* will close() automatically through dtor */
+#else
+  std::unique_ptr<std::streambuf> f;
+#endif
+  std::string filename;
+  INT64 _fsize;
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  std::wstring wfilename;
+#endif
+  FILE *jas_file;
 
-  private:
-    FILE *f,*sav;
-    const char *filename;
+public:
+  virtual ~LibRaw_file_datastream();
+  LibRaw_file_datastream(const char *fname);
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  LibRaw_file_datastream(const wchar_t *fname);
+#endif
+  virtual void *make_jas_stream();
+  virtual int valid();
+  virtual int read(void *ptr, size_t size, size_t nmemb);
+  virtual int eof();
+  virtual int seek(INT64 o, int whence);
+  virtual INT64 tell();
+  virtual INT64 size() { return _fsize; }
+  virtual int get_char() {return f->sbumpc();}
+  virtual char *gets(char *str, int sz);
+  virtual int scanf_one(const char *fmt, void *val);
+  virtual const char *fname();
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  virtual const wchar_t *wfname();
+#endif
 };
-#undef CHK
 
-class LibRaw_buffer_datastream : public LibRaw_abstract_datastream
+class DllDef LibRaw_buffer_datastream : public LibRaw_abstract_datastream
 {
-  public:
-    LibRaw_buffer_datastream(void *buffer, size_t bsize)
-        {
-            buf = (unsigned char*)buffer; streampos = 0; streamsize = bsize;
-        }
-    virtual ~LibRaw_buffer_datastream(){}
-    virtual int valid() { return buf?1:0;}
-    virtual int read(void * ptr,size_t sz, size_t nmemb) 
-    { 
-        if(substream) return substream->read(ptr,sz,nmemb);
-        size_t to_read = sz*nmemb;
-        if(to_read > streamsize - streampos)
-            to_read = streamsize-streampos;
-        if(to_read<1) 
-            return 0;
-        memmove(ptr,buf+streampos,to_read);
-        streampos+=to_read;
-        return int((to_read+sz-1)/sz);
-    }
+public:
+  LibRaw_buffer_datastream(void *buffer, size_t bsize);
+  virtual ~LibRaw_buffer_datastream();
+  virtual int valid();
+  virtual void *make_jas_stream();
+  virtual int jpeg_src(void *jpegdata);
+  virtual int read(void *ptr, size_t sz, size_t nmemb);
+  virtual int eof();
+  virtual int seek(INT64 o, int whence);
+  virtual INT64 tell();
+  virtual INT64 size() { return streamsize; }
+  virtual char *gets(char *s, int sz);
+  virtual int scanf_one(const char *fmt, void *val);
+  virtual int get_char()
+  {
+    if (streampos >= streamsize)   return -1;
+    return buf[streampos++];
+  }
+
+private:
+  unsigned char *buf;
+  size_t streampos, streamsize;
+};
 
-    virtual int eof() 
-    { 
-        if(substream) return substream->eof();
-        return streampos >= streamsize;
-    }
+class DllDef LibRaw_bigfile_datastream : public LibRaw_abstract_datastream
+{
+public:
+  LibRaw_bigfile_datastream(const char *fname);
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  LibRaw_bigfile_datastream(const wchar_t *fname);
+#endif
+  virtual ~LibRaw_bigfile_datastream();
+  virtual int valid();
+  virtual void *make_jas_stream();
+
+  virtual int read(void *ptr, size_t size, size_t nmemb);
+  virtual int eof();
+  virtual int seek(INT64 o, int whence);
+  virtual INT64 tell();
+  virtual INT64 size() { return _fsize; }
+  virtual char *gets(char *str, int sz);
+  virtual int scanf_one(const char *fmt, void *val);
+  virtual const char *fname();
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  virtual const wchar_t *wfname();
+#endif
+  virtual int get_char()
+  {
+#ifndef LIBRAW_WIN32_CALLS
+    return getc_unlocked(f);
+#else
+    return fgetc(f);
+#endif
+  }
 
-    virtual int seek(off_t o, int whence) 
-    { 
-        if(substream) return substream->seek(o,whence);
-        switch(whence)
-            {
-            case SEEK_SET:
-                if(o<0)
-                    streampos = 0;
-                else if (size_t(o) > streamsize)
-                    streampos = streamsize;
-                else
-                    streampos = size_t(o);
-                return 0;
-            case SEEK_CUR:
-                if(o<0)
-                    {
-                        if(size_t(-o) >= streampos)
-                            streampos = 0;
-                        else
-                            streampos += o;
-                    }
-                else if (o>0)
-                    {
-                        if(o+streampos> streamsize)
-                            streampos = streamsize;
-                        else
-                            streampos += o;
-                    }
-                return 0;
-            case SEEK_END:
-                if(o>0)
-                    streampos = streamsize;
-                else if ( size_t(-o) > streamsize)
-                    streampos = 0;
-                else
-                    streampos = streamsize+o;
-                return 0;
-            default:
-                return 0;
-            }
-    }
-    
-    virtual int tell() 
-    { 
-        if(substream) return substream->tell();
-        return int(streampos);
-    }
+protected:
+  FILE *f;
+  std::string filename;
+  INT64 _fsize;
+#ifdef LIBRAW_WIN32_UNICODEPATHS
+  std::wstring wfilename;
+#endif
+};
 
-    virtual int get_char() 
-    { 
-        if(substream) return substream->get_char();
-        if(streampos>=streamsize)
-            return -1;
-        return buf[streampos++];
-    }
-    virtual char* gets(char *s, int sz) 
-    { 
-        if (substream) return substream->gets(s,sz);
-        unsigned char *psrc,*pdest,*str;
-        str = (unsigned char *)s;
-        psrc = buf+streampos;
-        pdest = str;
-        while ( (size_t(psrc - buf) < streamsize)
-               &&
-                ((pdest-str)<sz)
-		)
-	  {
-                *pdest = *psrc;
-                if(*psrc == '\n')
-                    break;
-                psrc++;
-                pdest++;
-            }
-        if(size_t(psrc-buf) < streamsize)
-            psrc++;
-        if((pdest-str)<sz)
-            *(++pdest)=0;
-        streampos = psrc - buf;
-        return s;
-    }
-    virtual int scanf_one(const char *fmt, void* val) 
-    { 
-        if(substream) return substream->scanf_one(fmt,val);
-        int scanf_res;
-        if(streampos>streamsize) return 0;
-        scanf_res = sscanf((char*)(buf+streampos),fmt,val);
-        if(scanf_res>0)
-            {
-                int xcnt=0;
-                while(streampos<streamsize)
-                    {
-                        streampos++;
-                        xcnt++;
-                        if(buf[streampos] == 0
-                           || buf[streampos]==' '
-                           || buf[streampos]=='\t'
-                           || buf[streampos]=='\n'
-                           || xcnt>24)
-                            break;
-                    }
-            }
-        return scanf_res;
-    }
-  private:
-    unsigned char *buf;
-    size_t   streampos,streamsize;
+#ifdef LIBRAW_WIN32_CALLS
+class DllDef LibRaw_windows_datastream : public LibRaw_buffer_datastream
+{
+public:
+  /* ctor: high level constructor opens a file by name */
+  LibRaw_windows_datastream(const TCHAR *sFile);
+  /* ctor: construct with a file handle - caller is responsible for closing the
+   * file handle */
+  LibRaw_windows_datastream(HANDLE hFile);
+  /* dtor: unmap and close the mapping handle */
+  virtual ~LibRaw_windows_datastream();
+  virtual INT64 size() { return cbView_; }
+
+protected:
+  void Open(HANDLE hFile);
+  inline void reconstruct_base()
+  {
+    /* this subterfuge is to overcome the private-ness of
+     * LibRaw_buffer_datastream */
+    (LibRaw_buffer_datastream &)*this =
+        LibRaw_buffer_datastream(pView_, (size_t)cbView_);
+  }
+
+  HANDLE hMap_;    /* handle of the file mapping */
+  void *pView_;    /* pointer to the mapped memory */
+  __int64 cbView_; /* size of the mapping in bytes */
 };
 
-inline int LibRaw_abstract_datastream::tempbuffer_open(void  *buf, size_t size)
+#endif
+
+#ifdef USE_DNGSDK
+
+class libraw_dng_stream : public dng_stream
 {
-    if(substream) return EBUSY;
-    substream = new LibRaw_buffer_datastream(buf,size);
-    return substream?0:EINVAL;
-}
+public:
+  libraw_dng_stream(LibRaw_abstract_datastream *p)
+      : dng_stream((dng_abort_sniffer *)NULL, kBigBufferSize, 0),
+        parent_stream(p)
+  {
+    if (parent_stream)
+    {
+        parent_stream->buffering_off();
+      off = parent_stream->tell();
+      parent_stream->seek(0UL, SEEK_SET); /* seek to start */
+    }
+  }
+  ~libraw_dng_stream()
+  {
+    if (parent_stream)
+      parent_stream->seek(off, SEEK_SET);
+  }
+  virtual uint64 DoGetLength()
+  {
+    if (parent_stream)
+      return parent_stream->size();
+    return 0;
+  }
+  virtual void DoRead(void *data, uint32 count, uint64 offset)
+  {
+    if (parent_stream)
+    {
+      parent_stream->seek(offset, SEEK_SET);
+      parent_stream->read(data, 1, count);
+    }
+  }
 
+private:
+  libraw_dng_stream(const libraw_dng_stream &stream);
+  libraw_dng_stream &operator=(const libraw_dng_stream &stream);
+  LibRaw_abstract_datastream *parent_stream;
+  INT64 off;
+};
 
 #endif
 
-#endif
+#endif /* cplusplus */
 
+#endif
